<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    <script>
        // ----------Creating a Promise:-------------
        // const myPromise = new Promise((resolve, reject) => {
        // // Asynchronous operation
        // setTimeout(() => {
        //     const success = true;

        //     if (success) {
        //     resolve("Operation succeeded!");
        //     } else {
        //     reject("Operation failed!");
        //     }
        // }, 1000);
        // });

        //--------Handling the Promise:--------------
        // myPromise
        // .then((result) => {
        //     console.log(result); // Output: Operation succeeded!
        // })
        // .catch((error) => {
        //     console.error(error); // Output: Operation failed!
        // });

        //----------Chaining Promises:-------------
        // const myPromise = new Promise((resolve) => {
        // setTimeout(() => {
        //     resolve(1);
        // }, 1000);
        // });

        // myPromise
        // .then((result) => {
        //     console.log(result); // Output: 1
        //     return result + 1;
        // })
        // .then((result) => {
        //     console.log(result); // Output: 2
        //     return result * 2;
        // })
        // .then((result) => {
        //     console.log(result); // Output: 4
        // });


        //--------------------Async/Await:----------
        // async function fetchData() {
        //     return new Promise((resolve) => {
        //         // Simulating an asynchronous operation
        //         setTimeout(() => {
        //         const data = "Async data";
        //         resolve(data);
        //         }, 1000);
        //     });
        // }

        // async function fetchDataAndLog() {
        //     const result = await fetchData();
        //     console.log(result);
        // }

        // fetchDataAndLog();


        //await
        // async function fetchData() {
        // // Simulating an asynchronous operation
        // return new Promise((resolve) => {
        //     setTimeout(() => {
        //     const data = "Async data";
        //     resolve(data);
        //     }, 1000);
        // });
        // }

        // async function fetchDataAndLog() {
        // const result = await fetchData();
        // console.log(result); // Output: Async data
        // }

        // fetchDataAndLog();



    </script>
</body>
</html>